--- old/./mr_sas.c	Tue Nov  6 14:29:38 2012
+++ new/./mr_sas.c	Tue Nov  6 14:29:38 2012
@@ -3266,11 +3419,13 @@
 	}
 
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in abort_aen_cmd(). fw_outstanding=0x%X max_fw_cmds=0x%X",
-				instance->fw_outstanding, instance->max_fw_cmds);
+		con_log(CL_ANN1, (CE_WARN,
+		    "abort_aen_cmd():Failed to get a cmd for abort_aen_cmd"));
+		DTRACE_PROBE2(abort_mfi_err, uint16_t, instance->fw_outstanding,
+		    uint16_t, instance->max_fw_cmds);
 		return (DDI_FAILURE);
 	}
+
 	/* Clear the frame buffer and assign back the context id */
 	(void) memset((char *)&cmd->frame[0], 0, sizeof (union mrsas_frame));
 	ddi_put32(cmd->frame_dma_obj.acc_handle, &cmd->frame->hdr.context,
@@ -3323,12 +3478,13 @@
 
 
 static int
-mrsas_build_init_cmd(struct mrsas_instance *instance, struct mrsas_cmd **cmd_ptr)
+mrsas_build_init_cmd(struct mrsas_instance *instance,
+    struct mrsas_cmd **cmd_ptr)
 {
 	struct mrsas_cmd		*cmd;
 	struct mrsas_init_frame		*init_frame;
 	struct mrsas_init_queue_info	*initq_info;
-	struct mrsas_drv_ver		drv_ver_info;	
+	struct mrsas_drv_ver		drv_ver_info;
 
 
 	/*
@@ -3387,11 +3543,11 @@
 	    &init_frame->queue_info_new_phys_addr_hi, 0);
 
 
-	/* fill driver version information*/
+	/* fill driver version information */
 	fill_up_drv_ver(&drv_ver_info);
 
 	/* allocate the driver version data transfer buffer */
-	instance->drv_ver_dma_obj.size = sizeof(drv_ver_info.drv_ver);
+	instance->drv_ver_dma_obj.size = sizeof (drv_ver_info.drv_ver);
 	instance->drv_ver_dma_obj.dma_attr = mrsas_generic_dma_attr;
 	instance->drv_ver_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
 	instance->drv_ver_dma_obj.dma_attr.dma_attr_count_max = 0xFFFFFFFFU;
@@ -3404,17 +3560,18 @@
 		    "init_mfi : Could not allocate driver version buffer."));
 		return (DDI_FAILURE);
 	}
-	/* copy driver version to dma  buffer*/
-	(void) memset(instance->drv_ver_dma_obj.buffer, 0,sizeof(drv_ver_info.drv_ver));
+	/* copy driver version to dma buffer */
+	(void) memset(instance->drv_ver_dma_obj.buffer, 0,
+	    sizeof (drv_ver_info.drv_ver));
 	ddi_rep_put8(cmd->frame_dma_obj.acc_handle,
-		(uint8_t *)drv_ver_info.drv_ver,
-                (uint8_t *)instance->drv_ver_dma_obj.buffer, 
-		sizeof(drv_ver_info.drv_ver), DDI_DEV_AUTOINCR);	
+	    (uint8_t *)drv_ver_info.drv_ver,
+	    (uint8_t *)instance->drv_ver_dma_obj.buffer,
+	    sizeof (drv_ver_info.drv_ver), DDI_DEV_AUTOINCR);
 
 
-	/*copy driver version physical address to init frame*/
-	ddi_put64(cmd->frame_dma_obj.acc_handle,
-	    &init_frame->driverversion, instance->drv_ver_dma_obj.dma_cookie[0].dmac_address);
+	/* copy driver version physical address to init frame */
+	ddi_put64(cmd->frame_dma_obj.acc_handle, &init_frame->driverversion,
+	    instance->drv_ver_dma_obj.dma_cookie[0].dmac_address);
 
 	ddi_put32(cmd->frame_dma_obj.acc_handle, &init_frame->data_xfer_len,
 	    sizeof (struct mrsas_init_queue_info));
@@ -3431,37 +3588,49 @@
  * mrsas_init_adapter_ppc - Initialize MFI interface adapter.
  */
 int
-mrsas_init_adapter_ppc (struct mrsas_instance *instance)
+mrsas_init_adapter_ppc(struct mrsas_instance *instance)
 {
 	struct mrsas_cmd		*cmd;
 
-	/* allocate memory for mfi adapter(cmd pool, individual commands, mfi frames etc */
-	if (alloc_space_for_mfi(instance) != DDI_SUCCESS){
+	/*
+	 * allocate memory for mfi adapter(cmd pool, individual commands, mfi
+	 * frames etc
+	 */
+	if (alloc_space_for_mfi(instance) != DDI_SUCCESS) {
 		con_log(CL_ANN, (CE_NOTE,
-			"Error, failed to allocate memory for MFI adapter"));
-		return (DDI_FAILURE); 
+		    "Error, failed to allocate memory for MFI adapter"));
+		return (DDI_FAILURE);
 	}
 
 	/* Build INIT command */
 	cmd = get_mfi_pkt(instance);
 
-	if (mrsas_build_init_cmd(instance, &cmd) != DDI_SUCCESS){
-		con_log(CL_ANN, (CE_NOTE,
-			"Error, failed to build INIT command"));
+	if (mrsas_build_init_cmd(instance, &cmd) != DDI_SUCCESS) {
+		con_log(CL_ANN,
+		    (CE_NOTE, "Error, failed to build INIT command"));
 
 		goto fail_undo_alloc_mfi_space;
 	}
 
-	//Disalbe interrupt before sending init frame ( see linux driver code)
-	/* send INIT MFI frame in polled mode */
+	/*
+	 * Disable interrupt before sending init frame ( see linux driver code)
+	 * send INIT MFI frame in polled mode
+	 */
 	if (instance->func_ptr->issue_cmd_in_poll_mode(instance, cmd)) {
 		con_log(CL_ANN, (CE_WARN, "failed to init firmware"));
 		goto fail_fw_init;
 	}
 
-	if (instance->func_ptr->read_fw_status_reg(instance) & 0x04000000) {
+	if (mrsas_common_check(instance, cmd) != DDI_SUCCESS)
+		goto fail_fw_init;
+	return_mfi_pkt(instance, cmd);
+
+	if (ctio_enable &&
+	    (instance->func_ptr->read_fw_status_reg(instance) & 0x04000000)) {
 		con_log(CL_ANN, (CE_NOTE, "mr_sas: IEEE SGL's supported"));
 		instance->flag_ieee = 1;
+	} else {
+		instance->flag_ieee = 0;
 	}
 
 	instance->unroll.alloc_space_mfi = 1;
@@ -3471,7 +3640,7 @@
 
 
 fail_fw_init:
-	mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
+	(void) mrsas_free_dma_obj(instance, instance->drv_ver_dma_obj);
 
 fail_undo_alloc_mfi_space:
 	return_mfi_pkt(instance, cmd);
@@ -3485,7 +3654,7 @@
  * mrsas_init_adapter - Initialize adapter.
  */
 int
-mrsas_init_adapter (struct mrsas_instance *instance)
+mrsas_init_adapter(struct mrsas_instance *instance)
 {
 	struct mrsas_ctrl_info		ctrl_info;
 
@@ -3517,11 +3686,11 @@
 
 	/* Initialize adapter */
 	if (instance->func_ptr->init_adapter(instance) != DDI_SUCCESS) {
-		con_log(CL_ANN, (CE_WARN, "mr_sas: "
-			"could not initialize adapter"));
+		con_log(CL_ANN,
+		    (CE_WARN, "mr_sas: could not initialize adapter"));
 		return (DDI_FAILURE);
 	}
-	
+
 	/* gather misc FW related information */
 	instance->disable_online_ctrl_reset = 0;
 
@@ -3535,15 +3704,8 @@
 		    PAGESIZE / 512;
 	}
 
-	if (ctrl_info.properties.on_off_properties & DISABLE_OCR_PROP_FLAG) {
+	if (ctrl_info.properties.on_off_properties & DISABLE_OCR_PROP_FLAG)
 		instance->disable_online_ctrl_reset = 1;
-		con_log(CL_ANN1, (CE_NOTE,
-              		"Disable online control Flag is set\n"));
-	}
-	else {
-		con_log(CL_ANN1, (CE_NOTE,
-			"Disable online control Flag is not set\n"));	
-	}
 
 	return (DDI_SUCCESS);
 
@@ -3632,6 +3794,11 @@
 		return (DDI_FAILURE);
 	}
 
+	if (mrsas_common_check(instance, cmd) != DDI_SUCCESS) {
+		return_mfi_pkt(instance, cmd);
+		return (DDI_FAILURE);
+	}
+
 	return_mfi_app_pkt(instance, cmd);
 	con_log(CL_ANN1, (CE_CONT, "mrsas_issue_init_mfi: Done"));
 
@@ -3688,7 +3855,7 @@
 				WR_RESERVED0_REGISTER(MFI_INIT_CLEAR_HANDSHAKE |
 				    MFI_INIT_HOTPLUG, instance);
 			}
-			max_wait 	= (instance->tbolt == 1) ? 180 : 2;
+			max_wait	= (instance->tbolt == 1) ? 180 : 2;
 			cur_state	= MFI_STATE_WAIT_HANDSHAKE;
 			break;
 		case MFI_STATE_BOOT_MESSAGE_PENDING:
@@ -3706,7 +3873,7 @@
 				WR_RESERVED0_REGISTER(MFI_INIT_HOTPLUG,
 				    instance);
 			}
-			max_wait 	= (instance->tbolt == 1) ? 180 : 10;
+			max_wait	= (instance->tbolt == 1) ? 180 : 10;
 			cur_state	= MFI_STATE_BOOT_MESSAGE_PENDING;
 			break;
 		case MFI_STATE_OPERATIONAL:
@@ -3729,15 +3896,16 @@
 				for (i = 0; i < (10 * 1000); i++) {
 					status =
 					    RD_RESERVED0_REGISTER(instance);
-					if (status & 1)
+					if (status & 1) {
 						delay(1 *
 						    drv_usectohz(MILLISEC));
-					else
+					} else {
 						break;
+					}
 				}
 
 			}
-			max_wait 	= (instance->tbolt == 1) ? 180 : 10;
+			max_wait	= (instance->tbolt == 1) ? 180 : 10;
 			cur_state	= MFI_STATE_OPERATIONAL;
 			break;
 		case MFI_STATE_UNDEFINED:
@@ -3744,19 +3912,19 @@
 			/* this state should not last for more than 2 seconds */
 			con_log(CL_ANN1, (CE_NOTE, "FW state undefined"));
 
-			max_wait 	= (instance->tbolt == 1) ? 180 : 2;
+			max_wait	= (instance->tbolt == 1) ? 180 : 2;
 			cur_state	= MFI_STATE_UNDEFINED;
 			break;
 		case MFI_STATE_BB_INIT:
-			max_wait 	= (instance->tbolt == 1) ? 180 : 2;
+			max_wait	= (instance->tbolt == 1) ? 180 : 2;
 			cur_state	= MFI_STATE_BB_INIT;
 			break;
 		case MFI_STATE_FW_INIT:
-			max_wait 	= (instance->tbolt == 1) ? 180 : 2;
+			max_wait	= (instance->tbolt == 1) ? 180 : 2;
 			cur_state	= MFI_STATE_FW_INIT;
 			break;
 		case MFI_STATE_FW_INIT_2:
-			max_wait 	= 180;
+			max_wait	= 180;
 			cur_state	= MFI_STATE_FW_INIT_2;
 			break;
 		case MFI_STATE_DEVICE_SCAN:
@@ -3767,7 +3935,7 @@
 			    "Device scan in progress ...\n"));
 			break;
 		case MFI_STATE_FLUSH_CACHE:
-			max_wait 	= 180;
+			max_wait	= 180;
 			cur_state	= MFI_STATE_FLUSH_CACHE;
 			break;
 		default:
@@ -3807,22 +3975,22 @@
 		fw_ctrl = RD_IB_DOORBELL(instance);
 		con_log(CL_ANN1, (CE_CONT,
 		    "mfi_state_transition_to_ready:FW ctrl = 0x%x", fw_ctrl));
-	}
 
-#if 0
-	/*
-	 * Write 0xF to the doorbell register to do the following.
-	 * - Abort all outstanding commands (bit 0).
-	 * - Transition from OPERATIONAL to READY state (bit 1).
-	 * - Discard (possible) low MFA posted in 64-bit mode (bit-2).
-	 * - Set to release FW to continue running (i.e. BIOS handshake
-	 *   (bit 3).
-	 */
-	if (!instance->tbolt) {
+		/*
+		 * Write 0xF to the doorbell register to do the following.
+		 * - Abort all outstanding commands (bit 0).
+		 * - Transition from OPERATIONAL to READY state (bit 1).
+		 * - Discard (possible) low MFA posted in 64-bit mode (bit-2).
+		 * - Set to release FW to continue running (i.e. BIOS handshake
+		 *   (bit 3).
+		 */
 		WR_IB_DOORBELL(0xF, instance);
 	}
-#endif
 
+	if (mrsas_check_acc_handle(instance->regmap_handle) != DDI_SUCCESS) {
+		return (EIO);
+	}
+
 	return (DDI_SUCCESS);
 }
 
@@ -3846,9 +4014,9 @@
 	}
 
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in get_seq_num(). fw_outstanding=0x%X max_fw_cmds=0x%X",
-			instance->fw_outstanding, instance->max_fw_cmds);
+		cmn_err(CE_WARN, "mr_sas: failed to get a cmd");
+		DTRACE_PROBE2(seq_num_mfi_err, uint16_t,
+		    instance->fw_outstanding, uint16_t, instance->max_fw_cmds);
 		return (ENOMEM);
 	}
 
@@ -3857,7 +4025,7 @@
 	ddi_put32(cmd->frame_dma_obj.acc_handle, &cmd->frame->hdr.context,
 	    cmd->index);
 
-	dcmd	= &cmd->frame->dcmd;
+	dcmd = &cmd->frame->dcmd;
 
 	/* allocate the data transfer buffer */
 	dcmd_dma_obj.size = sizeof (struct mrsas_evt_log_info);
@@ -3968,7 +4136,6 @@
 {
 	struct mrsas_cmd		*cmd = NULL;
 	struct mrsas_dcmd_frame		*dcmd;
-	uint32_t	max_cmd = instance->max_fw_cmds;
 	if (instance->tbolt) {
 		cmd = get_raid_msg_mfi_pkt(instance);
 	} else {
@@ -3976,9 +4143,10 @@
 	}
 
 	if (!cmd) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in flush_cache(). fw_outstanding=0x%X max_fw_cmds=0x%X",
-				instance->fw_outstanding, instance->max_fw_cmds);
+		con_log(CL_ANN1, (CE_WARN,
+		    "flush_cache():Failed to get a cmd for flush_cache"));
+		DTRACE_PROBE2(flush_cache_err, uint16_t,
+		    instance->fw_outstanding, uint16_t, instance->max_fw_cmds);
 		return;
 	}
 
@@ -4032,7 +4200,6 @@
 service_mfi_aen(struct mrsas_instance *instance, struct mrsas_cmd *cmd)
 {
 	uint32_t	seq_num;
-	uint32_t	i;
 	struct mrsas_evt_detail *evt_detail =
 	    (struct mrsas_evt_detail *)instance->mfi_evt_detail_obj.buffer;
 	int		rval = 0;
@@ -4078,7 +4245,7 @@
 			if (instance->mr_ld_list[tgt].dip != NULL) {
 				mutex_enter(&instance->config_dev_mtx);
 				instance->mr_ld_list[tgt].flag =
-				    ~MRDRV_TGT_VALID;
+				    (uint8_t)~MRDRV_TGT_VALID;
 				mutex_exit(&instance->config_dev_mtx);
 				rval = mrsas_service_evt(instance, tgt, 0,
 				    MRSAS_EVT_UNCONFIG_TGT, NULL);
@@ -4093,7 +4260,7 @@
 	case MR_EVT_LD_DELETED: {
 		tgt = ddi_get16(acc_handle, &evt_detail->args.ld.target_id);
 		mutex_enter(&instance->config_dev_mtx);
-		instance->mr_ld_list[tgt].flag = ~MRDRV_TGT_VALID;
+		instance->mr_ld_list[tgt].flag = (uint8_t)~MRDRV_TGT_VALID;
 		mutex_exit(&instance->config_dev_mtx);
 		rval = mrsas_service_evt(instance,
 		    ddi_get16(acc_handle, &evt_detail->args.ld.target_id), 0,
@@ -4117,73 +4284,81 @@
 	} /* End of MR_EVT_LD_CREATED */
 
 #ifdef PDSUPPORT
-	case MR_EVT_PD_REMOVED_EXT: { 
+	case MR_EVT_PD_REMOVED_EXT: {
 		if (instance->tbolt) {
 			pd_addr = &evt_detail->args.pd_addr;
 			dtype = pd_addr->scsi_dev_type;
 			con_log(CL_DLEVEL1, (CE_NOTE,
-		    	   " MR_EVT_PD_REMOVED_EXT: dtype = %x," 
+			    " MR_EVT_PD_REMOVED_EXT: dtype = %x,"
 			    " arg_type = %d ", dtype, evt_detail->arg_type));
-			    tgt = ddi_get16(acc_handle, &evt_detail->args.pd.device_id);
+			tgt = ddi_get16(acc_handle,
+			    &evt_detail->args.pd.device_id);
 			mutex_enter(&instance->config_dev_mtx);
-			instance->mr_tbolt_pd_list[tgt].flag = (uint8_t)~MRDRV_TGT_VALID;
+			instance->mr_tbolt_pd_list[tgt].flag =
+			    (uint8_t)~MRDRV_TGT_VALID;
 			mutex_exit(&instance->config_dev_mtx);
-			rval = mrsas_service_evt(instance,
-		    	ddi_get16(acc_handle, &evt_detail->args.pd.device_id),
-		    	    1, MRSAS_EVT_UNCONFIG_TGT, NULL);
+			rval = mrsas_service_evt(instance, ddi_get16(
+			    acc_handle, &evt_detail->args.pd.device_id),
+			    1, MRSAS_EVT_UNCONFIG_TGT, NULL);
 			con_log(CL_ANN1, (CE_WARN, "mr_sas: PD_REMOVED:"
 			    "rval = %d tgt id = %d ", rval,
-			ddi_get16(acc_handle, &evt_detail->args.pd.device_id)));
-			break;
+			    ddi_get16(acc_handle,
+			    &evt_detail->args.pd.device_id)));
 		}
-	}/* End of MR_EVT_PD_REMOVED_EXT */
+		break;
+	} /* End of MR_EVT_PD_REMOVED_EXT */
 
 	case MR_EVT_PD_INSERTED_EXT: {
 		if (instance->tbolt) {
 			rval = mrsas_service_evt(instance,
-		    	ddi_get16(acc_handle, &evt_detail->args.pd.device_id),
-		    	    1, MRSAS_EVT_CONFIG_TGT, NULL);
+			    ddi_get16(acc_handle,
+			    &evt_detail->args.pd.device_id),
+			    1, MRSAS_EVT_CONFIG_TGT, NULL);
 			con_log(CL_ANN1, (CE_WARN, "mr_sas: PD_INSERTEDi_EXT:"
-		    	    "rval = %d tgt id = %d ", rval,
-		    	    ddi_get16(acc_handle, &evt_detail->args.pd.device_id)));
-			break;
+			    "rval = %d tgt id = %d ", rval,
+			    ddi_get16(acc_handle,
+			    &evt_detail->args.pd.device_id)));
 		}
-	}/* End of MR_EVT_PD_INSERTED_EXT */
+		break;
+	} /* End of MR_EVT_PD_INSERTED_EXT */
 
 	case MR_EVT_PD_STATE_CHANGE: {
 		if (instance->tbolt) {
-			tgt = ddi_get16(acc_handle, &evt_detail->args.pd.device_id);
-			if ((evt_detail->args.pd_state.prevState == PD_SYSTEM) &&
-		    	    (evt_detail->args.pd_state.newState != PD_SYSTEM)) {
+			tgt = ddi_get16(acc_handle,
+			    &evt_detail->args.pd.device_id);
+			if ((evt_detail->args.pd_state.prevState ==
+			    PD_SYSTEM) &&
+			    (evt_detail->args.pd_state.newState != PD_SYSTEM)) {
 				mutex_enter(&instance->config_dev_mtx);
 				instance->mr_tbolt_pd_list[tgt].flag =
-			    	    (uint8_t)~MRDRV_TGT_VALID;
+				    (uint8_t)~MRDRV_TGT_VALID;
 				mutex_exit(&instance->config_dev_mtx);
 				rval = mrsas_service_evt(instance,
-			   	    ddi_get16(acc_handle,
-			       	    &evt_detail->args.pd.device_id),
+				    ddi_get16(acc_handle,
+				    &evt_detail->args.pd.device_id),
 				    1, MRSAS_EVT_UNCONFIG_TGT, NULL);
 				con_log(CL_ANN1, (CE_WARN, "mr_sas: PD_REMOVED:"
-			    	    "rval = %d tgt id = %d ", rval,
-			    	    ddi_get16(acc_handle,
-			    	    &evt_detail->args.pd.device_id)));	
+				    "rval = %d tgt id = %d ", rval,
+				    ddi_get16(acc_handle,
+				    &evt_detail->args.pd.device_id)));
 				break;
-			}					
+			}
 			if ((evt_detail->args.pd_state.prevState
-		    	    == UNCONFIGURED_GOOD) &&
-		    	    (evt_detail->args.pd_state.newState == PD_SYSTEM)) {
+			    == UNCONFIGURED_GOOD) &&
+			    (evt_detail->args.pd_state.newState == PD_SYSTEM)) {
 				rval = mrsas_service_evt(instance,
-		    	    	ddi_get16(acc_handle,
-			    	    &evt_detail->args.pd.device_id),
-		    	    	    1, MRSAS_EVT_CONFIG_TGT, NULL);
+				    ddi_get16(acc_handle,
+				    &evt_detail->args.pd.device_id),
+				    1, MRSAS_EVT_CONFIG_TGT, NULL);
 				con_log(CL_ANN1, (CE_WARN,
-			    	    "mr_sas: PD_INSERTED: rval = %d "
-		    	    	    " tgt id = %d ", rval,
-			    	    ddi_get16(acc_handle,
-			    	    &evt_detail->args.pd.device_id)));
+				    "mr_sas: PD_INSERTED: rval = %d "
+				    " tgt id = %d ", rval,
+				    ddi_get16(acc_handle,
+				    &evt_detail->args.pd.device_id)));
 				break;
-			}	
+			}
 		}
+		break;
 	}
 #endif
 
@@ -4256,15 +4431,15 @@
 	if (fw_state == MFI_STATE_FAULT) {
 		if (instance->disable_online_ctrl_reset == 1) {
 			cmn_err(CE_WARN,
-				"mrsas_initiate_ocr_if_fw_is_faulty: "
-				"FW in Fault state, detected in ISR: "
-				"FW doesn't support ocr ");
+			    "mrsas_initiate_ocr_if_fw_is_faulty: "
+			    "FW in Fault state, detected in ISR: "
+			    "FW doesn't support ocr ");
 
 			return (ADAPTER_RESET_NOT_REQUIRED);
 		} else {
 			con_log(CL_ANN, (CE_NOTE,
-				"mrsas_initiate_ocr_if_fw_is_faulty: "
-				"FW in Fault state, detected in ISR: FW supports ocr "));
+			    "mrsas_initiate_ocr_if_fw_is_faulty: FW in Fault "
+			    "state, detected in ISR: FW supports ocr "));
 
 			return (ADAPTER_RESET_REQUIRED);
 		}
@@ -4318,6 +4493,16 @@
 		(void) ddi_dma_sync(cmd->frame_dma_obj.dma_handle,
 		    0, 0, DDI_DMA_SYNC_FORCPU);
 
+		if (mrsas_check_dma_handle(cmd->frame_dma_obj.dma_handle) !=
+		    DDI_SUCCESS) {
+			mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+			ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+			con_log(CL_ANN1, (CE_WARN,
+			    "mrsas_softintr: "
+			    "FMA check reports DMA handle failure"));
+			return (DDI_INTR_CLAIMED);
+		}
+
 		hdr = &cmd->frame->hdr;
 
 		/* remove the internal command from the process list */
@@ -4362,6 +4547,9 @@
 			    "CDB[0] = %x completed for %s: size %lx context %x",
 			    pkt->pkt_cdbp[0], ((acmd->islogical) ? "LD" : "PD"),
 			    acmd->cmd_dmacount, hdr->context));
+			DTRACE_PROBE3(softintr_cdb, uint8_t, pkt->pkt_cdbp[0],
+			    uint_t, acmd->cmd_cdblen, ulong_t,
+			    acmd->cmd_dmacount);
 
 			if (pkt->pkt_cdbp[0] == SCMD_INQUIRY) {
 				struct scsi_inquiry	*inq;
@@ -4390,6 +4578,9 @@
 				}
 			}
 
+			DTRACE_PROBE2(softintr_done, uint8_t, hdr->cmd,
+			    uint8_t, hdr->cmd_status);
+
 			switch (hdr->cmd_status) {
 			case MFI_STAT_OK:
 				pkt->pkt_scbp[0] = STATUS_GOOD;
@@ -4399,7 +4590,8 @@
 				pkt->pkt_scbp[0] = STATUS_GOOD;
 				break;
 			case MFI_STAT_LD_INIT_IN_PROGRESS:
-				con_log(CL_ANN, (CE_WARN, "Initialization in Progress"));
+				con_log(CL_ANN,
+				    (CE_WARN, "Initialization in Progress"));
 				pkt->pkt_reason	= CMD_TRAN_ERR;
 
 				break;
@@ -4411,9 +4603,8 @@
 				    pkt->pkt_scbp)->sts_chk = 1;
 
 				if (pkt->pkt_cdbp[0] == SCMD_TEST_UNIT_READY) {
-
-					con_log(CL_ANN, (CE_WARN, "TEST_UNIT_READY fail"));
-
+					con_log(CL_ANN,
+					    (CE_WARN, "TEST_UNIT_READY fail"));
 				} else {
 					pkt->pkt_state |= STATE_ARQ_DONE;
 					arqstat = (void *)(pkt->pkt_scbp);
@@ -4480,6 +4671,18 @@
 
 			atomic_add_16(&instance->fw_outstanding, (-1));
 
+			(void) mrsas_common_check(instance, cmd);
+
+			if (acmd->cmd_dmahandle) {
+				if (mrsas_check_dma_handle(
+				    acmd->cmd_dmahandle) != DDI_SUCCESS) {
+					ddi_fm_service_impact(instance->dip,
+					    DDI_SERVICE_UNAFFECTED);
+					pkt->pkt_reason = CMD_TRAN_ERR;
+					pkt->pkt_statistics = 0;
+				}
+			}
+
 			/* Call the callback routine */
 			if (((pkt->pkt_flags & FLAG_NOINTR) == 0) &&
 			    pkt->pkt_comp) {
@@ -4531,6 +4734,9 @@
 			break;
 
 		default:
+			mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+			ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+
 			if (cmd->pkt != NULL) {
 				pkt = cmd->pkt;
 				if (((pkt->pkt_flags & FLAG_NOINTR) == 0) &&
@@ -4608,10 +4814,6 @@
 
 		return (-1);
 	}
-	if (obj->dma_handle == NULL) {
-		con_log(CL_ANN, (CE_WARN, "Failed : ddi_dma_mem_alloc"));
-		return (-1);
-	}
 
 	if (ddi_dma_addr_bind_handle(obj->dma_handle, NULL, obj->buffer,
 	    obj->size, DDI_DMA_RDWR | DDI_DMA_STREAMING, DDI_DMA_SLEEP,
@@ -4624,14 +4826,16 @@
 
 		return (-1);
 	}
-	if (obj->acc_handle == NULL) {
-		ddi_dma_mem_free(&obj->acc_handle);
-		ddi_dma_free_handle(&obj->dma_handle);
 
-		con_log(CL_ANN, (CE_WARN, "Failed : ddi_dma_addr_bind_handle"));
+	if (mrsas_check_dma_handle(obj->dma_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
 		return (-1);
 	}
 
+	if (mrsas_check_acc_handle(obj->acc_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+		return (-1);
+	}
 
 	return (cookie_cnt);
 }
@@ -4646,10 +4850,24 @@
 mrsas_free_dma_obj(struct mrsas_instance *instance, dma_obj_t obj)
 {
 
-	if ( (obj.dma_handle == NULL) || (obj.acc_handle == NULL) ) {
+	if ((obj.dma_handle == NULL) || (obj.acc_handle == NULL)) {
 		return (DDI_SUCCESS);
 	}
 
+	/*
+	 * NOTE: These check-handle functions fail if *_handle == NULL, but
+	 * this function succeeds because of the previous check.
+	 */
+	if (mrsas_check_dma_handle(obj.dma_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+		return (DDI_FAILURE);
+	}
+
+	if (mrsas_check_acc_handle(obj.acc_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_UNAFFECTED);
+		return (DDI_FAILURE);
+	}
+
 	(void) ddi_dma_unbind_handle(obj.dma_handle);
 	ddi_dma_mem_free(&obj.acc_handle);
 	ddi_dma_free_handle(&obj.dma_handle);
@@ -4700,12 +4918,13 @@
 	tmp_dma_attr.dma_attr_sgllen = instance->max_num_sge;
 	tmp_dma_attr.dma_attr_addr_hi = 0xffffffffffffffffull;
 	if (instance->tbolt) {
-		//OCR-RESET FIX
-		tmp_dma_attr.dma_attr_count_max = (U64)mrsas_tbolt_max_cap_maxxfer;  //limit to 256K
-		tmp_dma_attr.dma_attr_maxxfer = (U64)mrsas_tbolt_max_cap_maxxfer;  //limit to 256K
+		/* OCR-RESET FIX */
+		tmp_dma_attr.dma_attr_count_max =
+		    (U64)mrsas_tbolt_max_cap_maxxfer;  /* limit to 256K */
+		tmp_dma_attr.dma_attr_maxxfer =
+		    (U64)mrsas_tbolt_max_cap_maxxfer;  /* limit to 256K */
 	}
 
-
 	if ((i = ddi_dma_alloc_handle(instance->dip, &tmp_dma_attr,
 	    cb, 0, &acmd->cmd_dmahandle)) != DDI_SUCCESS) {
 		switch (i) {
@@ -4886,7 +5105,7 @@
 {
 	uint16_t	flags = 0;
 	uint32_t	i;
-	uint32_t 	context;
+	uint32_t	context;
 	uint32_t	sge_bytes;
 	uint32_t	tmp_data_xfer_len;
 	ddi_acc_handle_t acc_handle;
@@ -4894,7 +5113,7 @@
 	struct mrsas_sge64		*mfi_sgl;
 	struct mrsas_sge_ieee		*mfi_sgl_ieee;
 	struct scsa_cmd			*acmd = PKT2CMD(pkt);
-	struct mrsas_pthru_frame 	*pthru;
+	struct mrsas_pthru_frame	*pthru;
 	struct mrsas_io_frame		*ldio;
 
 	/* find out if this is logical or physical drive command.  */
@@ -4904,9 +5123,8 @@
 
 	/* get the command packet */
 	if (!(cmd = get_mfi_pkt(instance))) {
-		cmn_err(CE_WARN,
-		    "Failed to get a cmd from free-pool in build_cmd(). fw_outstanding=0x%X max_fw_cmds=0x%X",
-				instance->fw_outstanding, instance->max_fw_cmds);
+		DTRACE_PROBE2(build_cmd_mfi_err, uint16_t,
+		    instance->fw_outstanding, uint16_t, instance->max_fw_cmds);
 		return (NULL);
 	}
 
@@ -4918,6 +5136,8 @@
 
 	cmd->pkt = pkt;
 	cmd->cmd = acmd;
+	DTRACE_PROBE3(build_cmds, uint8_t, pkt->pkt_cdbp[0],
+	    ulong_t, acmd->cmd_dmacount, ulong_t, acmd->cmd_dma_len);
 
 	/* lets get the command directions */
 	if (acmd->cmd_flags & CFLAG_DMASEND) {
@@ -4949,7 +5169,7 @@
 
 	/*
 	 * case SCMD_SYNCHRONIZE_CACHE:
-	 * 	flush_cache(instance);
+	 *	flush_cache(instance);
 	 *	return_mfi_pkt(instance, cmd);
 	 *	*cmd_done = 1;
 	 *
@@ -5002,7 +5222,8 @@
 
 			context = ddi_get32(acc_handle, &ldio->context);
 
-			if (acmd->cmd_cdblen == CDB_GROUP0) {			/* 6-byte cdb */
+			if (acmd->cmd_cdblen == CDB_GROUP0) {
+				/* 6-byte cdb */
 				ddi_put32(acc_handle, &ldio->lba_count, (
 				    (uint16_t)(pkt->pkt_cdbp[4])));
 
@@ -5011,7 +5232,8 @@
 				    ((uint32_t)(pkt->pkt_cdbp[2]) << 8) |
 				    ((uint32_t)((pkt->pkt_cdbp[1]) & 0x1F)
 				    << 16)));
-			} else if (acmd->cmd_cdblen == CDB_GROUP1) {		/* 10-byte cdb */
+			} else if (acmd->cmd_cdblen == CDB_GROUP1) {
+				/* 10-byte cdb */
 				ddi_put32(acc_handle, &ldio->lba_count, (
 				    ((uint16_t)(pkt->pkt_cdbp[8])) |
 				    ((uint16_t)(pkt->pkt_cdbp[7]) << 8)));
@@ -5021,7 +5243,8 @@
 				    ((uint32_t)(pkt->pkt_cdbp[4]) << 8) |
 				    ((uint32_t)(pkt->pkt_cdbp[3]) << 16) |
 				    ((uint32_t)(pkt->pkt_cdbp[2]) << 24)));
-			} else if (acmd->cmd_cdblen == CDB_GROUP5) {		/* 12-byte cdb */
+			} else if (acmd->cmd_cdblen == CDB_GROUP5) {
+				/* 12-byte cdb */
 				ddi_put32(acc_handle, &ldio->lba_count, (
 				    ((uint32_t)(pkt->pkt_cdbp[9])) |
 				    ((uint32_t)(pkt->pkt_cdbp[8]) << 8) |
@@ -5033,7 +5256,8 @@
 				    ((uint32_t)(pkt->pkt_cdbp[4]) << 8) |
 				    ((uint32_t)(pkt->pkt_cdbp[3]) << 16) |
 				    ((uint32_t)(pkt->pkt_cdbp[2]) << 24)));
-			} else if (acmd->cmd_cdblen == CDB_GROUP4) {		/* 16-byte cdb */
+			} else if (acmd->cmd_cdblen == CDB_GROUP4) {
+				/* 16-byte cdb */
 				ddi_put32(acc_handle, &ldio->lba_count, (
 				    ((uint32_t)(pkt->pkt_cdbp[13])) |
 				    ((uint32_t)(pkt->pkt_cdbp[12]) << 8) |
@@ -5149,6 +5373,7 @@
 	return (cmd);
 }
 
+#ifndef __sparc
 /*
  * wait_for_outstanding -	Wait for all outstanding cmds
  * @instance:				Adapter soft state
@@ -5177,8 +5402,8 @@
 
 	return (0);
 }
+#endif	/* __sparc */
 
-
 /*
  * issue_mfi_pthru
  */
@@ -5189,7 +5414,7 @@
 	void		*ubuf;
 	uint32_t	kphys_addr = 0;
 	uint32_t	xferlen = 0;
-	uint32_t new_xfer_length =0;
+	uint32_t	new_xfer_length = 0;
 	uint_t		model;
 	ddi_acc_handle_t	acc_handle = cmd->frame_dma_obj.acc_handle;
 	dma_obj_t			pthru_dma_obj;
@@ -5226,8 +5451,9 @@
 	if (xferlen) {
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//pthru_dma_obj.size = xferlen;
-		MRSAS_GET_BOUNDARY_ALIGNED_LEN(xferlen,new_xfer_length,PAGESIZE);	
+		/* pthru_dma_obj.size = xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(xferlen, new_xfer_length,
+		    PAGESIZE);
 		pthru_dma_obj.size = new_xfer_length;
 		pthru_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		pthru_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
@@ -5274,7 +5500,7 @@
 
 	ddi_put32(acc_handle, &pthru->sense_buf_phys_addr_hi, 0);
 	pthru->sense_buf_phys_addr_lo = cmd->sense_phys_addr;
-	/*ddi_put32(acc_handle, &pthru->sense_buf_phys_addr_lo, 0); */
+	/* ddi_put32(acc_handle, &pthru->sense_buf_phys_addr_lo, 0); */
 
 	ddi_rep_put8(acc_handle, (uint8_t *)kpthru->cdb, (uint8_t *)pthru->cdb,
 	    pthru->cdb_len, DDI_DEV_AUTOINCR);
@@ -5313,14 +5539,17 @@
 
 	con_log(CL_ANN, (CE_CONT, "issue_mfi_pthru: cmd_status %x, "
 	    "scsi_status %x", kpthru->cmd_status, kpthru->scsi_status));
-	
+	DTRACE_PROBE3(issue_pthru, uint8_t, kpthru->cmd, uint8_t,
+	    kpthru->cmd_status, uint8_t, kpthru->scsi_status);
+
 	if (kpthru->sense_len) {
-		uint sense_len = SENSE_LENGTH;
-		void *sense_ubuf = (void *)(ulong_t)kpthru->sense_buf_phys_addr_lo;
+		uint_t sense_len = SENSE_LENGTH;
+		void *sense_ubuf =
+		    (void *)(ulong_t)kpthru->sense_buf_phys_addr_lo;
 		if (kpthru->sense_len <= SENSE_LENGTH) {
 			sense_len = kpthru->sense_len;
 		}
-		
+
 		for (i = 0; i < sense_len; i++) {
 			if (ddi_copyout(
 			    (uint8_t *)cmd->sense+i,
@@ -5330,11 +5559,12 @@
 				    "copy to user space failed"));
 			}
 			con_log(CL_DLEVEL1, (CE_WARN,
-			    "Copying Sense info sense_buff[%d] = 0x%X\n",i,*((uint8_t *)cmd->sense+i)));
+			    "Copying Sense info sense_buff[%d] = 0x%X",
+			    i, *((uint8_t *)cmd->sense + i)));
 		}
 	}
 	(void) ddi_dma_sync(cmd->frame_dma_obj.dma_handle, 0, 0,
-		    DDI_DMA_SYNC_FORDEV);
+	    DDI_DMA_SYNC_FORDEV);
 
 	if (xferlen) {
 		/* free kernel buffer */
@@ -5355,7 +5585,7 @@
 	void		*ubuf;
 	uint32_t	kphys_addr = 0;
 	uint32_t	xferlen = 0;
-	uint32_t        new_xfer_length = 0; 
+	uint32_t	new_xfer_length = 0;
 	uint32_t	model;
 	dma_obj_t	dcmd_dma_obj;
 	struct mrsas_dcmd_frame	*kdcmd;
@@ -5366,8 +5596,8 @@
 	kdcmd = (struct mrsas_dcmd_frame *)&ioctl->frame[0];
 
 	if (instance->adapterresetinprogress) {
-		con_log(CL_ANN1, (CE_WARN, "Reset flag set, "
-		"returning mfi_pkt and setting TRAN_BUSY\n"));
+		con_log(CL_ANN1, (CE_NOTE, "Reset flag set, "
+		"returning mfi_pkt and setting TRAN_BUSY"));
 		return (DDI_FAILURE);
 	}
 	model = ddi_model_convert_from(mode & FMODELS);
@@ -5391,8 +5621,9 @@
 	if (xferlen) {
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//dcmd_dma_obj.size = xferlen;
-		 MRSAS_GET_BOUNDARY_ALIGNED_LEN(xferlen,new_xfer_length,PAGESIZE);
+		/* dcmd_dma_obj.size = xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(xferlen, new_xfer_length,
+		    PAGESIZE);
 		dcmd_dma_obj.size = new_xfer_length;
 		dcmd_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		dcmd_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
@@ -5403,8 +5634,9 @@
 		/* allocate kernel buffer for DMA */
 			if (mrsas_alloc_dma_obj(instance, &dcmd_dma_obj,
 			    (uchar_t)DDI_STRUCTURE_LE_ACC) != 1) {
-				con_log(CL_ANN, (CE_WARN, "issue_mfi_dcmd: "
-				    "could not allocate data transfer buffer."));
+				con_log(CL_ANN,
+				    (CE_WARN, "issue_mfi_dcmd: could not "
+				    "allocate data transfer buffer."));
 				return (DDI_FAILURE);
 			}
 		(void) memset(dcmd_dma_obj.buffer, 0, xferlen);
@@ -5466,12 +5698,15 @@
 	}
 
 	kdcmd->cmd_status = ddi_get8(acc_handle, &dcmd->cmd_status);
-	con_log(CL_ANN, (CE_CONT, "issue_mfi_dcmd: cmd_status %x", kdcmd->cmd_status));
+	con_log(CL_ANN,
+	    (CE_CONT, "issue_mfi_dcmd: cmd_status %x", kdcmd->cmd_status));
+	DTRACE_PROBE3(issue_dcmd, uint32_t, kdcmd->opcode, uint8_t,
+	    kdcmd->cmd, uint8_t, kdcmd->cmd_status);
 
 	if (xferlen) {
 		/* free kernel buffer */
-			if (mrsas_free_dma_obj(instance, dcmd_dma_obj) != DDI_SUCCESS)
-				return (DDI_FAILURE);
+		if (mrsas_free_dma_obj(instance, dcmd_dma_obj) != DDI_SUCCESS)
+			return (DDI_FAILURE);
 	}
 
 	return (DDI_SUCCESS);
@@ -5557,8 +5792,9 @@
 	if (request_xferlen) {
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//request_dma_obj.size = request_xferlen;
-		MRSAS_GET_BOUNDARY_ALIGNED_LEN(request_xferlen,new_xfer_length1,PAGESIZE);
+		/* request_dma_obj.size = request_xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(request_xferlen,
+		    new_xfer_length1, PAGESIZE);
 		request_dma_obj.size = new_xfer_length1;
 		request_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		request_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
@@ -5590,8 +5826,9 @@
 	if (response_xferlen) {
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//response_dma_obj.size = response_xferlen;
-		MRSAS_GET_BOUNDARY_ALIGNED_LEN(response_xferlen,new_xfer_length2,PAGESIZE);
+		/* response_dma_obj.size = response_xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(response_xferlen,
+		    new_xfer_length2, PAGESIZE);
 		response_dma_obj.size = new_xfer_length2;
 		response_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		response_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
@@ -5721,6 +5958,7 @@
 	ksmp->cmd_status = ddi_get8(acc_handle, &smp->cmd_status);
 	con_log(CL_ANN1, (CE_NOTE, "issue_mfi_smp: smp->cmd_status = %d",
 	    ksmp->cmd_status));
+	DTRACE_PROBE2(issue_smp, uint8_t, ksmp->cmd, uint8_t, ksmp->cmd_status);
 
 	if (request_xferlen) {
 		/* free kernel buffer */
@@ -5777,9 +6015,7 @@
 
 		fis_ubuf	= (void *)(ulong_t)kstp->sgl.sge32[0].phys_addr;
 		data_ubuf	= (void *)(ulong_t)kstp->sgl.sge32[1].phys_addr;
-	}
-	else
-	{
+	} else {
 #ifdef _ILP32
 		con_log(CL_ANN1, (CE_CONT, "issue_mfi_stp: DDI_MODEL_ILP32"));
 
@@ -5806,8 +6042,9 @@
 
 		/* means IOCTL requires DMA */
 		/* allocate the data transfer buffer */
-		//fis_dma_obj.size = fis_xferlen;
-		MRSAS_GET_BOUNDARY_ALIGNED_LEN(fis_xferlen,new_xfer_length1,PAGESIZE);	
+		/* fis_dma_obj.size = fis_xferlen; */
+		MRSAS_GET_BOUNDARY_ALIGNED_LEN(fis_xferlen,
+		    new_xfer_length1, PAGESIZE);
 		fis_dma_obj.size = new_xfer_length1;
 		fis_dma_obj.dma_attr = mrsas_generic_dma_attr;
 		fis_dma_obj.dma_attr.dma_attr_addr_hi = 0xFFFFFFFFU;
